/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ppp_hdlc.h,v 1.5 2009/12/24 05:42:40 abe Exp $
 */

/*
 *	    Written by Toshiharu OHNO (tony-o@iij.ad.jp)
 *
 *   Copyright (C) 1993, Internet Initiative Japan, Inc. All rights reserverd.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Internet Initiative Japan.  The name of the
 * IIJ may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $FreeBSD: src/usr.sbin/ppp/hdlc.h,v 1.21 1999/12/30 13:27:15 brian Exp $
 *
 *	TODO:
 */

#ifndef _PPP__HDLC_H_
#define _PPP__HDLC_H_

#ifdef SUPPORT_PPP

/*
 *  RFC1171 (PPP)  HDLC 
 */

/*
 *  
 */

#define HDLC_FLAG_SEQ		UINT_C(0x7e)		/* Flag Sequence			*/
#define HDLC_CNTL_ESC		UINT_C(0x7d)		/* Control Escape octet			*/
#define HDLC_ADDR_ALL		UINT_C(0xff)		/* Address: All-Stations		*/
#define HDLC_CNTL_UI		UINT_C(0x03)		/* Control: UI				*/
#define HDLC_ESC_MASK		UINT_C(0x20)		/* Escape Mask				*/
#define HDLC_INIT_FCS		UINT_C(0xffff)		/* Initial FCS value			*/
#define HDLC_INIT_FCS_AC	UINT_C(0x3de3)		/* Initial FCS value with		*/
							/* Address and Control: UI		*/
#define HDLC_GOOD_FCS		UINT_C(0xf0b8)		/* Good final FCS value			*/

/*
 *  ؿ
 */

extern ER HDLC_write (T_NET_BUF *data);
extern ER HDLC_read (T_NET_BUF *data, uint16_t size);
extern void HDLC_dummy_read (void);

#ifdef PPP_CFG_MODEM

extern int_t HDLC_raw_getoctet (void);
extern void HDLC_raw_putoctet (uint8_t ch);

#endif	/* of #ifdef PPP_CFG_MODEM */

#endif	/* of #ifdef SUPPORT_PPP */

#endif	/* of #ifndef _PPP__HDLC_H_ */
